﻿// 2011年02月18日 グラフ表示だいたい出来た
// 2011年02月19日 ログをファイルに記録
// 2011年02月25日 通信書きなおし
// 2011年02月26日 パラメーター変更できた 噴射マップ書き換えできた
// 2011年02月28日 点火マップ編集、窓位置を覚えるようにした
// 2011年03月03日 フラグ位置間違い修正
// 2011年03月04日 シリアルポートオープン例外無視
// 2011年03月05日 マップセーブ燃料カット後ISCV追加
// 2011年03月06日 ISCVのモニタ追加
// 2011年04月23日 通信部分書き換え
// 2011年05月13日 ニュートラルスイッチのモニタ追加 通信タイムアウト処理修正
// 2011年05月15日 通信タイムアウト処理修正
// 2011年06月27日 表示少修正
// 2011年06月30日 マップトレース追加
// 2011年07月01日 ボタンを押すとマップトレース表示を更新するように変更（リアルタイムだとネットブックで重いので）。距離表示単位の間違いを修正。
// 2011年07月02日 表示少修正。COMポート名保存。窓の表示静態保存。コグに時間を記録するよう変更。

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;  // SerialPort.GetPortNames()を使うために追加
//using System.Threading; // sleep()を使うために追加
using System.IO;    // 追加 ファイル操作で使用


namespace WindowsFormsApplication1
{
    public partial class Fmain : Form
    {
        Finjmap finjmap = new Finjmap();
        Flogging flogging = new Flogging();
        Finjmapedit finjmapedit = new Finjmapedit();
        Finjmap fignmap = new Finjmap();
        Finjmapedit fignmapedit = new Finjmapedit();
        byte[,] InjCompMap = new byte[16, 25];
        bool InjCompMapLoaded = false;
        byte[,] MapReadCount = 
        {
        {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
        {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
        {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
        {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
        {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
        {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
        {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
        {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
        {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
        {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
        {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
        {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
        {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
        {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
        {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
        {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
        };

        bool CONNECTED = false;
        volatile byte COMMAND = 0;
        //byte[] COMMAND = new byte[10];
        //byte COMMANDIDX = 0;
        //uint TIMEOUT;
        uint STATUS, RPM, AIR, INJIDX_A1, INJIDX_A2, INJIDX_R1, INJIDX_R2;
        uint MONINJ, MONIGN, O2, KNOCK, SPEED, DISTANCE, ISCVSTEP;
        int WATER_TEMP, AIR_TEMP, OIL_TEMP;
        ulong INJTOTAL;

        public Fmain()
        {
            InitializeComponent();

            try
            {
                comboBox1.Items.AddRange(SerialPort.GetPortNames());    // 有効なシリアルポート一覧を取得してコンボボックスにセット
                comboBox1.SelectedIndex = 0;
            }
            catch
            {
                button1.Enabled = false;    //例外が発生した（シリアルポートがない）時、ボタンを押せなくする
            }

            readini();

            //finjmap.Show();
            //flogging.Show();
            //finjmapedit.Show();
            finjmapedit.opeenabled(false);
            fignmap.settitle("点火マップ");
            fignmap.maxval = 50;
            //fignmap.Show();
            fignmapedit.settitle("点火マップ[EDIT]");
            //fignmapedit.Show();
            fignmapedit.opeenabled(false);
            fignmapedit.setcolumwidth(25);
            flogging.logenabled(false);
            parameterEnabled(false);
        }

        // 接続ボタン
        private void button1_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen == false)    // オープン済みじゃないか調べる
            {
                serialPort1.PortName = (string)comboBox1.SelectedItem;
                serialPort1.BaudRate = 19200;
                serialPort1.DataBits = 8;              // 8ビット
                serialPort1.Parity = Parity.None;      // パリティ無し
                serialPort1.StopBits = StopBits.One;
                serialPort1.RtsEnable = Enabled;       // RTC/DTR 端子の状態をセット
                serialPort1.DtrEnable = Enabled;
                serialPort1.Handshake = Handshake.None;    // ハンドシェイク無し
                serialPort1.ReadTimeout = 800;

                try
                {
                    serialPort1.Open();
                }
                catch
                {
                }

                if (serialPort1.IsOpen == true)
                {
                    button1.Text = "切断";

                    CONNECTED = false;
                    timer1.Interval = 100;   // タイマーの間隔をセット
                    timer1.Enabled = Enabled;   // タイマースタート
                }
            }
            else
            {
                serialPort1.Close();        // オープン済みならクローズ
                timer1.Enabled = false;   // タイマーストップ
                CONNECTED = false;
                button1.Text = "接続";
                parameterEnabled(false);
                flogging.logenabled(false);
            }
        }

        // 1バイト送信
        /*        private void putch(byte a)
                {
                    byte[] buff = new byte[1];

                    buff[0] = a;
                    serialPort1.Write(buff, 0, 1);
                    //textBox2.Text += buff[0].ToString("X2");
                }
        */
        // 1バイト送信
        public bool putch(byte a)
        {
            byte[] buff = new byte[1];

            buff[0] = a;
            try
            {
                serialPort1.Write(buff, 0, 1);
            }
            catch
            {
                return false;
            }
            return true;
        }

        // 指定サイズを受信するまで待つ
        // タイムアウトはserialPortのReadTimeoutプロパティで指定
        public bool readbyte(byte[] buff, int size)
        {
            bool ret = true;

            try
            {
                int offset = 0;
                while (true)    // 指定したサイズを読むまで繰り返す
                {
                    int readsize;
                    readsize = serialPort1.Read(buff, offset, size);
                    if (readsize == size) break;    // 実際に指定したサイズを読んだら終了
                    else
                    {
                        size -= readsize;
                        offset += readsize;
                    }
                    //Application.DoEvents();
                }
            }
            catch
            {
                // タイムアウトとかの例外が発生した時
                ret = false;
                //putmsg("受信エラー");

                // タイムアウトで通信ポートを閉じる
                serialPort1.Close();
                timer1.Enabled = false;   // タイマーストップ
                CONNECTED = false;
                button1.Text = "接続";
                parameterEnabled(false);
                flogging.logenabled(false);
                textBox1.Clear();
                textBox1.AppendText("通信タイムアウト");

            }

            return ret;
        }

        // 指定バイト文受信するまで指定時間待つ
        // 戻り値 true:受信できた false:タイムアウト
        //        private bool waitbyte(int len/*受信バイト数*/, uint time/*待ち時間*10ms*/)
        /*        {
                    bool ret = false;

                    for (; time > 0; time--)
                    {
                        if (serialPort1.BytesToRead > len - 1)
                        {
                            ret = true;
                            break;
                        }
                        Thread.Sleep(10);
                    }
                    return ret;
                }
        */

        // 1バイト受信
        /*        private byte getch()
                {
                    return (byte)serialPort1.ReadByte();
                }
        */

        // 100msタイマー
        private void timer1_Tick(object sender, EventArgs e)
        {
            byte[] buff = new byte[1024];

            if (CONNECTED == false)
            {
                COMMAND = 0xAA;
                parameterEnabled(false);
            }
            switch (COMMAND)
            {
                // 接続テスト
                case 0x30:
                case 0xAA:
                    serialPort1.DiscardInBuffer();  // 受信バッファクリア
                    putch(COMMAND);
                    flogging.logenabled(false);
                    if (readbyte(buff, 1))    // 1バイト受信するまで待つ
                    {
                        // 受信できた
                        if (buff[0] == COMMAND)
                        {
                            CONNECTED = true;
                            COMMAND = 0x03;

                            parameterinit();
                            flogging.logenabled(true);
                        }
                    }
                    break;

                // ステータス受信
                case 0x01:
                    serialPort1.DiscardInBuffer();  // 受信バッファクリア
                    putch(0x01);
                    if (readbyte(buff, 23))    // 23バイト受信するまで待つ
                    {
                        // 受信成功
                        int a = 0;
                        STATUS = (uint)(buff[a++] << 8);
                        STATUS += (uint)buff[a++];
                        RPM = (uint)(buff[a++] << 8);
                        RPM |= (uint)buff[a++];
                        AIR = (uint)buff[a++];
                        INJIDX_A1 = (uint)buff[a++];
                        INJIDX_A2 = (uint)buff[a++];
                        INJIDX_R1 = (uint)buff[a++];
                        INJIDX_R2 = (uint)buff[a++];
                        MONINJ = (uint)(buff[a++] << 8);
                        MONINJ |= (uint)buff[a++];
                        MONINJ = MONINJ * 10;
                        MONIGN = (uint)buff[a++];
                        O2 = (uint)buff[a++];
                        KNOCK = (uint)buff[a++];
                        WATER_TEMP = (int)buff[a++] - 50;
                        AIR_TEMP = (int)buff[a++] - 50;
                        OIL_TEMP = buff[a++];
                        ISCVSTEP = buff[a++];
                        SPEED = (uint)buff[a++];
                        DISTANCE = (uint)(buff[a++] << (8 * 3));
                        DISTANCE += (uint)(buff[a++] << (8 * 2));
                        DISTANCE += (uint)(buff[a++] << (8 * 1));
                        DISTANCE += (uint)(buff[a++]);

                        if (RPM == 0)   // 回っていないときは前回の値が残るのでクリアする
                        {
                            INJIDX_A1 = 0;
                            INJIDX_A2 = 0;
                            INJIDX_R1 = 0;
                            INJIDX_R2 = 0;
                            MONINJ = 0;
                            MONIGN = 0;
                        }
                    }
                    else
                    {
                        // 受信失敗
                        CONNECTED = false;
                    }
                    break;

                // ECUリセットからのインジェクタ開弁時間合計[us]
                case 0x02:
                    serialPort1.DiscardInBuffer();  // 受信バッファクリア
                    putch(COMMAND);
                    if (readbyte(buff, 8))
                    {
                        int a = 0;
                        INJTOTAL = (ulong)buff[a++] << (8 * 7);
                        INJTOTAL += (ulong)buff[a++] << (8 * 6);
                        INJTOTAL += (ulong)buff[a++] << (8 * 5);
                        INJTOTAL += (ulong)buff[a++] << (8 * 4);
                        INJTOTAL += (ulong)buff[a++] << (8 * 3);
                        INJTOTAL += (ulong)buff[a++] << (8 * 2);
                        INJTOTAL += (ulong)buff[a++] << (8 * 1);
                        INJTOTAL += (ulong)buff[a++];
                        COMMAND = 0x01;
                    }
                    else
                    {
                        CONNECTED = false;
                    }
                    break;

                // 噴射基本マップECUからリード
                case 0x03:
                    serialPort1.DiscardInBuffer();  // 受信バッファクリア
                    putch(COMMAND);
                    if (readbyte(buff, 800))
                    {
                        int a, b, temp, pos = 0;
                        for (a = 0; a < 16; a++)
                        {
                            for (b = 0; b < 25; b++)
                            {
                                temp = buff[pos++] << 8;
                                temp |= buff[pos++];
                                finjmap.setmap(a, b, (uint)temp);
                                finjmapedit.setmap(a, b, (uint)temp);
                                finjmapedit.opeenabled(true);
                            }
                        }
                        COMMAND = 0x05;
                    }
                    else
                    {
                        CONNECTED = false;
                    }
                    break;

                // 噴射補正マップECUからリード
                case 0x04:
                    serialPort1.DiscardInBuffer();  // 受信バッファクリア
                    putch(COMMAND);
                    if (readbyte(buff, 400))
                    {
                        string str;
                        int a, b, temp, pos = 0;
                        str = "\r\n噴射補正マップ " + DateTime.Now.ToString() + "\r\n"
                        + "/*       240 230 220 210 200 190 180 170 160 150 140 130 120 110 100  90  80  70  60  50  40  30  20  10   0 */\r\n";
                        for (a = 0; a < 16; a++)
                        {
                            str += String.Format("/*{0,4:D}*/ ", (a + 1) * 500);
                            for (b = 0; b < 25; b++)
                            {
                                temp = buff[pos++];
                                InjCompMap[a, b] = (byte)temp;
                                str += String.Format("{0,3:D},", temp);
                            }
                            str += "\r\n";
                        }
                        str += "\r\n";
                        puterr(str);
                        COMMAND = 0x01;
                        InjCompMapLoaded = true;
                    }
                    else
                    {
                        CONNECTED = false;
                    }
                    break;

                // 点火マップECUからリード
                case 0x05:
                    serialPort1.DiscardInBuffer();  // 受信バッファクリア
                    putch(COMMAND);
                    if (readbyte(buff, 400))
                    {
                        int a, b, temp, pos = 0;
                        for (a = 0; a < 16; a++)
                        {
                            for (b = 0; b < 25; b++)
                            {
                                temp = buff[pos++];
                                fignmap.setmap(a, b, (byte)temp);
                                fignmapedit.setmap(a, b, (byte)temp);
                                fignmapedit.opeenabled(true);
                            }
                        }
                        COMMAND = 0x01;
                    }
                    else
                    {
                        CONNECTED = false;
                    }
                    break;


                case 0x40:  // 空燃比フィードバック補正禁止フラグクリア
                case 0x41:  // 空燃比フィードバック補正禁止フラグセット
                case 0x45:  // 噴射基本マップ初期化
                case 0x46:  // 噴射補正マップ初期化
                case 0x47:  // 点火マップ初期化
                case 0x48:  // 温度センサー異常フラグクリア
                case 0x49:  // そのほかのパラメーターとSTATUS初期化
                case 0x4A:  // インジェクタ累積開弁時間クリア
                case 0x4B:  // 走行距離リセット
                    serialPort1.DiscardInBuffer();  // 受信バッファクリア
                    putch(COMMAND);
                    if (readbyte(buff, 1))
                    {
                        if (buff[0] == COMMAND) //エコー確認
                        {
                            COMMAND = 0xAA;
                        }
                    }
                    CONNECTED = false;  // いったん未接続にすることで、自動的にパラメーターを再読込
                    break;

            }

            if (CONNECTED == true)
            {
                // ログのグラフ更新
                flogging.update();

                // マップの読んだ位置を記録
                if ((INJIDX_R1 != 0)&&(INJIDX_R2 != 0)&&(INJIDX_A1 != 0)&&(INJIDX_A2 != 0))   // 噴射していないときは更新しない
                {
                    MapReadCount[INJIDX_R1, INJIDX_A1] += 4;
                    if (MapReadCount[INJIDX_R1, INJIDX_A1] > 250) MapReadCount[INJIDX_R1, INJIDX_A1] = 250;
                    MapReadCount[INJIDX_R1, INJIDX_A2] += 4;
                    if (MapReadCount[INJIDX_R1, INJIDX_A2] > 250) MapReadCount[INJIDX_R1, INJIDX_A2] = 250;
                    MapReadCount[INJIDX_R2, INJIDX_A1] += 4;
                    if (MapReadCount[INJIDX_R2, INJIDX_A1] > 250) MapReadCount[INJIDX_R2, INJIDX_A1] = 250;
                    MapReadCount[INJIDX_R2, INJIDX_A2] += 4;
                    if (MapReadCount[INJIDX_R2, INJIDX_A2] > 250) MapReadCount[INJIDX_R2, INJIDX_A2] = 250;
                }

                disp();
            }

            finjmap.forcus_r = finjmapedit.forcus_r;
            finjmap.forcus_a = finjmapedit.forcus_a;
            fignmap.forcus_r = fignmapedit.forcus_r;
            fignmap.forcus_a = fignmapedit.forcus_a;

            // 噴射マップが変更された
            if (finjmapedit.changed == true)
            {
                finjmap.setmap(finjmapedit.idx_r, finjmapedit.idx_a, finjmapedit.val);
                injmapput((byte)finjmapedit.idx_r, (byte)finjmapedit.idx_a, finjmapedit.val);
                finjmapedit.changed = false;
                //finjmapedit.opeenabled(true);
            }

            // 噴射マップ自動編集
            if (finjmapedit.autoedit == true)
            {
                injcomp(finjmapedit.forcus_r, finjmapedit.forcus_a);
                finjmapedit.autoedit = false;
            }


            // 点火マップが変更された
            if (fignmapedit.changed == true)
            {
                fignmap.setmap(fignmapedit.idx_r, fignmapedit.idx_a, fignmapedit.val);
                ignmapput((byte)fignmapedit.idx_r, (byte)fignmapedit.idx_a, (byte)fignmapedit.val);
                fignmapedit.changed = false;
            }
        }

        // 噴射補正マップの値を噴射マップに適用する
        private void injcomp(int r, int a)
        {
            if (InjCompMapLoaded == true)   // 噴射補正マップが配列に入っている
            {
                uint temp;
                temp = finjmapedit.getmap(r, a);
                if ((temp != 0) && (InjCompMap[r, a] != 0))
                {
                    temp = (uint)(temp * ((float)InjCompMap[r, a] / 100));
                }
                InjCompMap[r, a] = 100;
                injcompmapput((byte)r, (byte)a, 100);
                finjmapedit.setmap(r, a, temp);
                finjmap.setmap(r, a, temp);
                injmapput((byte)r, (byte)a, temp);
            }
        }

        // 表示
        // textBox1.AppendText()や
        // textBox1.Text += "文字列"
        // を何度も使うと遅いので（特にネットブックで）
        // 文字列変数に表示する文字を入れておいて、いっきに表示したほうがいいみたい
        private void disp()
        {
            string str;
            //textBox1.Clear();
            str = "回転数:" + RPM.ToString("D4") + " RPM\r\n"
            + "吸気量:" + AIR.ToString("D3") + "\r\n"
            + "水温:" + WATER_TEMP.ToString("D3") + "\r\n"
            + "吸気温:" + AIR_TEMP.ToString("D3") + "\r\n"
            + "油温:" + OIL_TEMP.ToString("D3") + "\r\n"
                /*    
                    + "A1:" + INJIDX_A1.ToString("D2") + "\r\n"
                    + "A2:" + INJIDX_A2.ToString("D2") + "\r\n"
                    + "R1:" + INJIDX_R1.ToString("D2") + "\r\n"
                    + "R2:" + INJIDX_R2.ToString("D2") + "\r\n"
                */
            + "噴射時間:" + MONINJ.ToString("D5") + " ns\r\n"
            + "点火時期:BTDC " + MONIGN.ToString("D2") + "\r\n"
            + "O2:" + O2.ToString("D3") + "\r\n";
            if ((STATUS & (1 << 8)) == 0) str += "空燃比:リーン \r\n";
            else str += "空燃比:リッチ \r\n";
            str += "KNOCK:" + KNOCK.ToString("D3") + "\r\n"
            + "ISCV:" + ISCVSTEP.ToString("D3") + " %\r\n"
            + "速度:" + SPEED.ToString("D") + " km/h\r\n"
            + "距離:" + DISTANCE.ToString("D") + " m\r\n"
            + "STATUS:" + STATUS.ToString("X4") + "\r\n";
            if ((STATUS & (1 << 0)) != 0) str += "過回転 ";
            if ((STATUS & (1 << 1)) != 0) str += "エンブレ ";
            if ((STATUS & (1 << 2)) != 0) str += "アイドルアップ ";
            if ((STATUS & (1 << 3)) != 0) str += "始動モード ";
            if ((STATUS & (1 << 4)) != 0) str += "温度補正 ";
            if ((STATUS & (1 << 5)) != 0) str += "加速補正 ";
            if ((STATUS & (1 << 6)) == 0) str += "噴射禁止 ";
            if ((STATUS & (1 << 7)) != 0)
            {
                str += "空燃比フィードバック補正禁止 ";
                checkBox1.Checked = true;
            }
            else
            {
                checkBox1.Checked = false;
            }
            if ((STATUS & (1 << 9)) != 0) str += "O2センサー異常 ";
            if ((STATUS & (1 << 10)) != 0) str += "吸気温センサー異常 ";
            if ((STATUS & (1 << 11)) != 0) str += "水温センサー異常 ";
            if ((STATUS & (1 << 12)) != 0) str += "温度補正禁止 ";
            if ((STATUS & (1 << 13)) != 0) str += "IDL ";
            if ((STATUS & (1 << 15)) == 0) str += "ニュートラル ";
            str += "\r\nCONNECTED:" + CONNECTED.ToString();
            if (flogging.logging == true) str += "\r\nログ記録中";
            str += "\r\n" + DateTime.Now.ToString();  // 2011/02/20 3:17:00
            //str += "\r\n" + DateTime.Now.ToString("yyyyMMdd");    // 20110220

            textBox1.Text = str;

            flogging.speed = SPEED;
            flogging.distance = DISTANCE;
            flogging.rpm = RPM;
            flogging.air = AIR;
            flogging.inj = MONINJ;
            flogging.ign = MONIGN;
            flogging.water_temp = WATER_TEMP;
            flogging.air_temp = AIR_TEMP;
            flogging.oil_temp = OIL_TEMP;
            flogging.o2 = O2;
            flogging.knock = KNOCK;

            // マップのグラフ更新
            if (finjmap.Visible == true)    // 表示されているときだけ
            {
                finjmap.draw1(INJIDX_R1, INJIDX_R2, INJIDX_A1, INJIDX_A2);   // 噴射マップのグラフ更新
            }

            if (fignmap.Visible == true)
            {
                fignmap.draw2(INJIDX_R1, INJIDX_R2, INJIDX_A1, INJIDX_A2);
            }

            // マップの表の色変え（マップトレース）
            // ネットブックだとリアルタイムで表示を更新すると遅い。修正したほうが良い
            /*
            finjmapedit.setcount((int)INJIDX_R1, (int)INJIDX_A1, MapReadCount[INJIDX_R1, INJIDX_A1]);
            finjmapedit.setcount((int)INJIDX_R1, (int)INJIDX_A2, MapReadCount[INJIDX_R1, INJIDX_A2]);
            finjmapedit.setcount((int)INJIDX_R2, (int)INJIDX_A1, MapReadCount[INJIDX_R2, INJIDX_A1]);
            finjmapedit.setcount((int)INJIDX_R2, (int)INJIDX_A2, MapReadCount[INJIDX_R2, INJIDX_A2]);

            fignmapedit.setcount((int)INJIDX_R1, (int)INJIDX_A1, MapReadCount[INJIDX_R1, INJIDX_A1]);
            fignmapedit.setcount((int)INJIDX_R1, (int)INJIDX_A2, MapReadCount[INJIDX_R1, INJIDX_A2]);
            fignmapedit.setcount((int)INJIDX_R2, (int)INJIDX_A1, MapReadCount[INJIDX_R2, INJIDX_A1]);
            fignmapedit.setcount((int)INJIDX_R2, (int)INJIDX_A2, MapReadCount[INJIDX_R2, INJIDX_A2]);
            */
        }

        private void puterr(string str)
        {
            textBox2.AppendText(str);
        }

        // 噴射基本マップ書き込み
        // [0x42]-[idx_r]-[idx_a]-[VAL_H]-[VAL_L]
        private void injmapput(byte r, byte a, uint val)
        {
            //timer1.Enabled = false; // 処理中はタイマー停止（タイマーイベントで通信がされないように）
            serialPort1.DiscardInBuffer();  // 受信バッファクリア
            putch(0x42);
            CONNECTED = false;
            byte[] buff = new byte[2];
            if (readbyte(buff, 1))
            {
                if (buff[0] == 0x42) //エコー確認
                {
                    putch(r);
                    putch(a);
                    putch((byte)((val >> 8) & 0xFF));
                    putch((byte)(val & 0xFF));
                    if (readbyte(buff, 2))
                    {
                        uint temp;
                        // 送信した値のエコーが帰る
                        temp = (uint)(buff[0] << 8);
                        temp += buff[1];
                        finjmap.setmap(r, a, temp);
                        finjmapedit.setmap(r, a, temp);

                        CONNECTED = true;
                    }
                }
            }
            //timer1.Enabled = true;
        }

        // 噴射補正マップ書き込み
        // [0x43]-[idx_r]-[idx_a]-[VAL]
        private void injcompmapput(byte r, byte a, byte val)
        {
            //timer1.Enabled = false; // 処理中はタイマー停止（タイマーイベントで通信がされないように）
            serialPort1.DiscardInBuffer();  // 受信バッファクリア
            putch(0x43);
            CONNECTED = false;
            byte[] buff = new byte[2];
            if (readbyte(buff, 1))
            {
                if (buff[0] == 0x43) //エコー確認
                {
                    putch(r);
                    putch(a);
                    putch(val);
                    if (readbyte(buff, 1))
                    {
                        // 送信した値のエコーが帰る
                        byte temp;
                        temp = buff[0];
                        InjCompMap[r, a] = temp;
                        CONNECTED = true;
                    }
                }
            }
            //timer1.Enabled = true;
        }
        // 点火基本マップ書き込み
        private void ignmapput(byte r, byte a, byte val)
        {
            //timer1.Enabled = false; // 処理中はタイマー停止（タイマーイベントで通信がされないように）
            serialPort1.DiscardInBuffer();  // 受信バッファクリア
            putch(0x44);
            CONNECTED = false;
            byte[] buff = new byte[2];
            if (readbyte(buff, 1))
            {
                if (buff[0] == 0x44) //エコー確認
                {
                    putch(r);
                    putch(a);
                    putch(val);
                    if (readbyte(buff, 1))
                    {
                        byte temp;
                        // 送信した値のエコーが帰る
                        temp = buff[0];
                        fignmap.setmap(r, a, temp);
                        fignmapedit.setmap(r, a, temp);
                        CONNECTED = true;
                    }
                }
            }
            //timer1.Enabled = true;
        }

        private byte put8(byte command, byte val)
        {
            byte ret = 0;
            timer1.Enabled = false; // 処理中はタイマー停止（タイマーイベントで通信がされないように）
            serialPort1.DiscardInBuffer();  // 受信バッファクリア
            putch(command);
            CONNECTED = false;
            byte[] buff = new byte[2];
            if (readbyte(buff, 1))
            {
                if (buff[0] == command) //エコー確認
                {
                    putch(val);
                    if (readbyte(buff, 1))
                    {
                        // 送信した値のエコーが帰る
                        ret = buff[0];
                        CONNECTED = true;
                    }
                }
            }
            timer1.Enabled = true;
            return ret;
        }

        private uint put16(byte command, ushort val)
        {
            uint ret = 0;
            timer1.Enabled = false; // 処理中はタイマー停止（タイマーイベントで通信がされないように）
            serialPort1.DiscardInBuffer();  // 受信バッファクリア
            putch(command);
            CONNECTED = false;
            byte[] buff = new byte[2];
            if (readbyte(buff, 1))
            {
                if (buff[0] == command) //エコー確認
                {
                    putch((byte)((val >> 8)));
                    putch((byte)(val));
                    if (readbyte(buff, 2))
                    {
                        // 送信した値のエコーが帰る
                        ret = (uint)buff[0] << 8;
                        ret += (uint)buff[1];
                        CONNECTED = true;
                    }
                }
            }
            timer1.Enabled = true;
            return ret;
        }

        // textbox の入力処理
        // TextChanged イベントだと一文字入力するたびにイベントが発生してしまうので keyUp にした
        private void RevLimit_KeyUp(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)    // エンターキーが押された
            {
                ushort temp;
                if (ushort.TryParse(RevLimit.Text, out temp))
                {   // 値のチェックはECU側でやっている
                    RevLimit.Text = put16(0x4C, temp).ToString("D");
                }
            }
        }

        private void RevLimitCLR_KeyUp(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                ushort temp;
                if (ushort.TryParse(RevLimitCLR.Text, out temp))
                {
                    RevLimitCLR.Text = put16(0x4D, temp).ToString("D");
                }
            }
        }

        private void Idle_KeyUp(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                ushort temp;
                if (ushort.TryParse(Idle.Text, out temp))
                {
                    Idle.Text = put16(0x4F, temp).ToString("D");
                }
            }
        }

        private void IdleLoad_KeyUp(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                ushort temp;
                if (ushort.TryParse(IdleLoad.Text, out temp))
                {
                    IdleLoad.Text = put16(0x50, temp).ToString("D");
                }
            }
        }

        private void AccelComp_KeyUp(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                byte temp;
                if (byte.TryParse(AccelComp.Text, out temp))
                {
                    AccelComp.Text = put8(0x53, temp).ToString("D");
                }
            }
        }

        private void AccelCompTH_KeyUp(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                byte temp;
                if (byte.TryParse(AccelCompTH.Text, out temp))
                {
                    AccelCompTH.Text = put8(0x54, temp).ToString("D");
                }
            }
        }

        private void FuelCut_KeyUp(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                ushort temp;
                if (ushort.TryParse(FuelCut.Text, out temp))
                {
                    FuelCut.Text = put16(0x4E, temp).ToString("D");
                }
            }
        }

        private void InjResume_KeyUp(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                byte temp;
                if (byte.TryParse(InjResume.Text, out temp))
                {
                    InjResume.Text = put8(0x52, temp).ToString("D");
                }
            }
        }

        private void Dwell_KeyUp(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                byte temp;
                if (byte.TryParse(Dwell.Text, out temp))
                {
                    Dwell.Text = put8(0x51, temp).ToString("D");
                }
            }
        }

        private void InjResumeISCV_KeyUp(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                byte temp;
                if (byte.TryParse(InjResumeISCV.Text, out temp))
                {
                    InjResumeISCV.Text = put8(0x55, temp).ToString("D");
                }
            }
        }

        private void ISCVmin_KeyUp(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                byte temp;
                if (byte.TryParse(ISCVmin.Text, out temp))
                {
                    ISCVmin.Text = put8(0x56, temp).ToString("D");
                }
            }
        }

        // パラメーター初期化
        // ECUからパラメータを読んでtextboxにセット
        private void parameterinit()
        {
            RevLimit.Text = put16(0x4C, 0).ToString("D");
            RevLimitCLR.Text = put16(0x4D, 0).ToString("D");
            Idle.Text = put16(0x4F, 0).ToString("D");
            IdleLoad.Text = put16(0x50, 0).ToString("D");
            AccelComp.Text = put8(0x53, 0).ToString("D");
            AccelCompTH.Text = put8(0x54, 0).ToString("D");
            FuelCut.Text = put16(0x4E, 0).ToString("D");
            InjResume.Text = put8(0x52, 0).ToString("D");
            Dwell.Text = put8(0x51, 0).ToString("D");
            InjResumeISCV.Text = put8(0x55, 0).ToString("D");
            ISCVmin.Text = put8(0x56, 0).ToString("D");

            parameterEnabled(true);
        }

        // textboxのenabledプロパティをまとめで変更
        public void parameterEnabled(bool a)
        {
            RevLimit.Enabled = a;
            RevLimitCLR.Enabled = a;
            Idle.Enabled = a;
            IdleLoad.Enabled = a;
            AccelComp.Enabled = a;
            AccelCompTH.Enabled = a;
            FuelCut.Enabled = a;
            InjResume.Enabled = a;
            Dwell.Enabled = a;
            InjResumeISCV.Enabled = a;
            ISCVmin.Enabled = a;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            // パラメーター初期化
            COMMAND = 0x49;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            // 温度センサー異常フラグクリア
            COMMAND = 0x48;
        }

        private void button4_Click(object sender, EventArgs e)
        {
            // 噴射マップ初期化
            COMMAND = 0x45;
        }

        private void button5_Click(object sender, EventArgs e)
        {
            // 点火マップ初期化
            COMMAND = 0x47;
        }

        // 噴射補正表示ボタン
        private void button6_Click(object sender, EventArgs e)
        {
            COMMAND = 0x04;
        }

        // マップトレースボタン
        private void button7_Click(object sender, EventArgs e)
        {
            for (int r = 0; r < 16; r++) 
            {
                for (int a = 0; a < 25; a++)
                {
                    finjmapedit.setcount(r, a, MapReadCount[r, a]);
                    fignmapedit.setcount(r, a, MapReadCount[r, a]);
                }
            }
        }

        // 噴射補正適用ボタン
        private void button8_Click(object sender, EventArgs e)
        {
            if (InjCompMapLoaded == true)   // 噴射補正マップが配列に入っている
            {
                puterr("数十秒くらいかかります\r\n処理中 …… ");
                for (int r = 0; r < 16; r++)
                {
                    for (int a = 0; a < 25; a++)
                    {
                        injcomp(r, a);
                    }
                }
                puterr("終了\r\n");
            }
            else
            {
                puterr("補正マップを読み込んでから噴射補正適用ボタンを遅てください\r\n");
            }
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox1.Checked == true)
            {
                // フィードバック補正禁止
                COMMAND = 0x41;
            }
            else
            {
                // フィードバック許可
                COMMAND = 0x40;
            }
        }

        // メニュー
        // 表示(V)
        // 噴射マップ
        private void 噴射マップToolStripMenuItem_Click(object sender, EventArgs e)
        {
            finjmap.Show();
            finjmapedit.Show();
            finjmapedit.Focus();
            finjmap.Focus();
        }

        // 点火マップ
        private void ignitionToolStripMenuItem_Click(object sender, EventArgs e)
        {
            fignmap.Show();
            fignmapedit.Show();
            fignmapedit.Focus();
            fignmap.Focus();
        }

        // ログ
        private void ログToolStripMenuItem_Click(object sender, EventArgs e)
        {
            flogging.Show();
            flogging.Focus();
        }

        // フォームが閉じるとき
        // フォームの位置とサイズを保存する
        private void Fmain_FormClosing(object sender, FormClosingEventArgs e)
        {
            string[] str = new string[30];
            str[0] = this.Location.X.ToString();
            str[1] = this.Location.Y.ToString();
            str[2] = this.Size.Width.ToString();
            str[3] = this.Size.Height.ToString();
            str[4] = flogging.Location.X.ToString();
            str[5] = flogging.Location.Y.ToString();
            str[6] = flogging.Size.Width.ToString();
            str[7] = flogging.Size.Height.ToString();
            str[8] = finjmap.Location.X.ToString();
            str[9] = finjmap.Location.Y.ToString();
            str[10] = finjmap.Size.Width.ToString();
            str[11] = finjmap.Size.Height.ToString();
            str[12] = finjmapedit.Location.X.ToString();
            str[13] = finjmapedit.Location.Y.ToString();
            str[14] = finjmapedit.Size.Width.ToString();
            str[15] = finjmapedit.Size.Height.ToString();
            str[16] = fignmap.Location.X.ToString();
            str[17] = fignmap.Location.Y.ToString();
            str[18] = fignmap.Size.Width.ToString();
            str[19] = fignmap.Size.Height.ToString();
            str[20] = fignmapedit.Location.X.ToString();
            str[21] = fignmapedit.Location.Y.ToString();
            str[22] = fignmapedit.Size.Width.ToString();
            str[23] = fignmapedit.Size.Height.ToString();
            str[24] = serialPort1.PortName;
            str[25] = flogging.Visible.ToString();
            str[26] = finjmap.Visible.ToString();
            str[27] = finjmapedit.Visible.ToString();
            str[28] = fignmap.Visible.ToString();
            str[29] = fignmapedit.Visible.ToString();
            File.WriteAllLines(this.Text + ".ini", str);
        }

        // フォームの位置とサイズを読み出す
        private void readini()
        {
            try
            {
                int a;
                string[] str = File.ReadAllLines(this.Text + ".ini");
                this.StartPosition = FormStartPosition.Manual;
                flogging.StartPosition = FormStartPosition.Manual;
                finjmap.StartPosition = FormStartPosition.Manual;
                finjmapedit.StartPosition = FormStartPosition.Manual;
                fignmap.StartPosition = FormStartPosition.Manual;
                fignmapedit.StartPosition = FormStartPosition.Manual;

                for (int b = 0; b < str.Length; b++)
                {
                    if (int.TryParse(str[b], out a))
                    {
                        switch (b)
                        {
                            case 0: this.Left = a; break;
                            case 1: this.Top = a; break;
                            case 2: this.Width = a; break;
                            case 3: this.Height = a; break;
                            case 4: flogging.Left = a; break;
                            case 5: flogging.Top = a; break;
                            case 6: flogging.Width = a; break;
                            case 7: flogging.Height = a; break;
                            case 8: finjmap.Left = a; break;
                            case 9: finjmap.Top = a; break;
                            case 10: finjmap.Width = a; break;
                            case 11: finjmap.Height = a; break;
                            case 12: finjmapedit.Left = a; break;
                            case 13: finjmapedit.Top = a; break;
                            case 14: finjmapedit.Width = a; break;
                            case 15: finjmapedit.Height = a; break;
                            case 16: fignmap.Left = a; break;
                            case 17: fignmap.Top = a; break;
                            case 18: fignmap.Width = a; break;
                            case 19: fignmap.Height = a; break;
                            case 20: fignmapedit.Left = a; break;
                            case 21: fignmapedit.Top = a; break;
                            case 22: fignmapedit.Width = a; break;
                            case 23: fignmapedit.Height = a; break;
                        }
                    }
                    switch (b)
                    {
                        case 24: puterr(str[b]);
                            {
                                int idx;
                                idx = comboBox1.FindStringExact(str[b]);
                                if (idx > -1) comboBox1.SelectedIndex = idx;
                                break;
                            }
                        case 25:
                            if (str[b] == "True") flogging.Visible = true;
                            break;
                        case 26:
                            if (str[b] == "True") finjmap.Visible = true;
                            break;
                        case 27:
                            if (str[b] == "True") finjmapedit.Visible = true;
                            break;
                        case 28:
                            if (str[b] == "True") fignmap.Visible = true;
                            break;
                        case 29:
                            if (str[b] == "True") fignmapedit.Visible = true;
                            break;
                    }
                }
            }
            catch { }
        }

        // メニュー
        // ファイル(F)
        // 噴射マップ保存
        private void saveinjmapToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string str;
            str = "\r\n噴射マップ " + DateTime.Now.ToString() + "\r\n";
            str += "/*         240,  230,  220,  210,  200,  190,  180,  170,  160,  150,  140,  130,  120,  110,  100,   90,   80,   70,   60,   50,   40,   30,   20,   10,    0 */\r\n";
            for (int a = 0; a < 16; a++)
            {
                str += String.Format("/*{0,4:D}*/ ", (a + 1) * 500);
                for (int b = 0; b < 25; b++)
                {
                    str += String.Format("{0,5:D},", finjmap.readmap(a, b));
                }
                str += "\r\n";
            }
            string filename = DateTime.Now.ToString("yyyyMMdd") + "INJ.h";
            File.AppendAllText(filename, str);
        }

        // 噴射補正マップ保存
        private void savecompmapToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string str;
            str = "\r\n噴射補正マップ " + DateTime.Now.ToString() + "\r\n";
            str += "/*       240 230 220 210 200 190 180 170 160 150 140 130 120 110 100  90  80  70  60  50  40  30  20  10   0 */\r\n";
            for (int a = 0; a < 16; a++)
            {
                str += String.Format("/*{0,4:D}*/ ", (a + 1) * 500);
                for (int b = 0; b < 25; b++)
                {
                    str += String.Format("{0,3:D},", InjCompMap[a, b]);
                }
                str += "\r\n";
            }
            string filename = DateTime.Now.ToString("yyyyMMdd") + "CMP.h";
            File.AppendAllText(filename, str);
        }

        // 点火マップ保存
        private void saveignmapToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string str;
            str = "\r\n点火マップ " + DateTime.Now.ToString() + "\r\n";
            str += "/*       240 230 220 210 200 190 180 170 160 150 140 130 120 110 100  90  80  70  60  50  40  30  20  10   0 */\r\n";
            for (int a = 0; a < 16; a++)
            {
                str += String.Format("/*{0,4:D}*/ ", (a + 1) * 500);
                for (int b = 0; b < 25; b++)
                {
                    str += String.Format("{0,3:D},", fignmap.readmap(a, b));
                }
                str += "\r\n";
            }
            string filename = DateTime.Now.ToString("yyyyMMdd") + "IGN.h";
            File.AppendAllText(filename, str);
        }

    }
}
